﻿(function errorsModule()
{
    "use strict";
    var format = BingApp.Utilities.format;
    WinJS.Namespace.define("BingApp.Classes",{
        ErrorInvalidOperation: WinJS.Class.derive(Error,function constructor(operationName, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorInvalidOperation))
            {
                BingApp.traceWarning("ErrorInvalidOperation.ctor: Attempted using ErrorInvalidOperation ctor as function; redirecting to use 'new ErrorInvalidOperation()'.");
                return new BingApp.Classes.ErrorInvalidOperation(operationName,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(operationName))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("operationName");
            this.name = "BingApp.Errors.InvalidOperation";
            this.message = message || format(WinJS.Resources.getString("error_invalid_operation").value,operationName);
            this.operationName = operationName
        }),
        ErrorArgument: WinJS.Class.derive(Error,function constructor(argumentName, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorArgument))
            {
                BingApp.traceWarning("ErrorArgument.ctor: Attempted using ErrorArgument ctor as function; redirecting to use 'new ErrorArgument()'.");
                return new BingApp.Classes.ErrorArgument(argumentName,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(argumentName))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("argumentName");
            this.name = "BingApp.Errors.Argument";
            this.message = message || format(WinJS.Resources.getString("error_argument").value,argumentName);
            this.argumentName = argumentName
        }),
        ErrorArgumentNullOrUndefined: WinJS.Class.derive(Error,function constructor(argumentName, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorArgumentNullOrUndefined))
            {
                BingApp.traceWarning("ErrorArgumentNullOrUndefined.ctor: Attempted using ErrorArgumentNullOrUndefined ctor as function; redirecting to use 'new ErrorArgumentNullOrUndefined()'.");
                return new BingApp.Classes.ErrorArgumentNullOrUndefined(argumentName,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(argumentName))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("argumentName");
            this.name = "BingApp.Errors.ArgumentNullOrUndefined";
            this.message = message || format(WinJS.Resources.getString("error_argument_null_or_undefined").value,argumentName);
            this.argumentName = argumentName
        }),
        ErrorNavigationPath: WinJS.Class.derive(Error,function constructor(path, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorNavigationPath))
            {
                BingApp.traceWarning("ErrorNavigationPath.ctor: Attempted using ErrorNavigationPath ctor as function; redirecting to use 'new ErrorNavigationPath()'.");
                return new BingApp.Classes.ErrorNavigationPath(path,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(path))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("path");
            this.name = "BingApp.Errors.NavigationPath";
            this.message = message || format(WinJS.Resources.getString("error_navigation_path").value,path);
            this.path = path
        }),
        ErrorViewRegistration: WinJS.Class.derive(Error,function constructor(viewId, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorViewRegistration))
            {
                BingApp.traceWarning("ErrorViewRegistration.ctor: Attempted using ErrorViewRegistration ctor as function; redirecting to use 'new ErrorViewRegistration()'.");
                return new BingApp.Classes.ErrorViewRegistration(viewId,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(viewId))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("viewId");
            this.name = "BingApp.Errors.ViewRegistration";
            this.message = message || format(WinJS.Resources.getString("error_view_not_registered").value,viewId);
            this.viewId = viewId
        }),
        ErrorViewLoadingFailure: WinJS.Class.derive(Error,function constructor(viewId, message)
        {
            if(!(this instanceof BingApp.Classes.ErrorViewLoadingFailure))
            {
                BingApp.traceWarning("ErrorViewLoadingFailure.ctor: Attempted using ErrorViewLoadingFailure ctor as function; redirecting to use 'new ErrorViewLoadingFailure()'.");
                return new BingApp.Classes.ErrorViewLoadingFailure(viewId,message)
            }
            if(BingApp.Utilities.isNullOrUndefined(viewId))
                throw new BingApp.Classes.ErrorArgumentNullOrUndefined("viewId");
            this.name = "BingApp.Errors.ViewLoadingFailure";
            this.message = message || format(WinJS.Resources.getString("error_view_failed_to_load").value,viewId);
            this.viewId = viewId
        })
    })
})()