﻿(function queryStringCollectionModule()
{
    "use strict";
    var encodeExceptions = {setflight: true};
    function parse(queryString, options)
    {
        var collection = {};
        if(!queryString)
            return collection;
        var search = queryString.substr(queryString.indexOf("?") + 1);
        var decode = function decode(e)
            {
                return e
            };
        if(options && options.decode)
            decode = function decode(e)
            {
                return decodeURIComponent(e.replace(/\+/g,"%20"))
            };
        search.split("&").forEach(function parseQueryStringPair(pair)
        {
            var parts = pair.split("=",2);
            var key = decode(parts[0]);
            var value = parts[1] || "";
            if(value)
                value = decode(value);
            if(key.trim())
            {
                BingApp.traceVerbose("BingApp.Utilities.QueryString.parse: key='{0}', value='{1}'",key,value);
                collection[key] = value
            }
        });
        BingApp.traceVerbose("BingApp.Utilities.QueryString.parse: {0} to {1}",queryString,JSON.stringify(collection));
        return collection
    }
    function serialize(collection)
    {
        var params = [];
        if(collection)
            Object.keys(collection).forEach(function serializePair(key)
            {
                if(key.toLowerCase() in encodeExceptions)
                    params.push(key + "=" + collection[key]);
                else
                    params.push(encodeURIComponent(key) + "=" + encodeURIComponent(collection[key]))
            });
        var queryString = "?" + params.join("&");
        BingApp.traceVerbose("BingApp.Utilities.QueryString.serialize: {0} to {1}",JSON.stringify(collection),queryString);
        return queryString
    }
    function remove(queryString, keys)
    {
        if(!queryString || !keys)
            return queryString;
        if(typeof keys === "string")
            keys = [keys];
        var queryCollection = parse(queryString,{decode: true});
        keys.forEach(function removeKey(key)
        {
            delete queryCollection[key]
        });
        return serialize(queryCollection)
    }
    WinJS.Namespace.define("BingApp.Utilities.QueryString",{
        parse: parse,
        serialize: serialize,
        remove: remove
    })
})()