﻿(function filePickerModule()
{
    "use strict";
    function initializeView(viewModel, windowObject, documentObject)
    {
        WinJS.Resources.processAll();
        if(documentObject.body.currentStyle.direction === BingApp.Classes.FilePickerViewModel.rightToLeftDirection)
            WinJS.Utilities.addClass(windowObject.listView,"rightToLeftCheckMark");
        else
            WinJS.Utilities.addClass(windowObject.listView,"leftToRightCheckMark");
        viewModel.bindings.bind("selectionIndices",function updateListViewSelection(newSelectionIndices)
        {
            windowObject.listView.winControl.onselectionchanged = null;
            windowObject.listView.winControl.selection.set(newSelectionIndices).then(function restoreSelectionChangedHandler()
            {
                windowObject.listView.winControl.onselectionchanged = viewModel.handleSelectionChanged
            })
        });
        viewModel.bindings.bind("selectionErrorIndex",function showSelectionErrorFlyout(newSelectionErrorIndex)
        {
            if(newSelectionErrorIndex >= 0)
                windowObject.selectionErrorFlyout.winControl.show(windowObject.listView.winControl.elementFromIndex(newSelectionErrorIndex))
        });
        WinJS.Binding.processAll(null,viewModel).then(function updateCaretPosition()
        {
            var textLength = windowObject.searchBox.value.length;
            windowObject.searchBox.setSelectionRange(textLength,textLength)
        }).then(function()
        {
            windowObject.onresize = function handleResize()
            {
                var searchBoxHeight = windowObject.header.clientHeight;
                windowObject.contentContainer.style.height = documentObject.body.clientHeight - searchBoxHeight + "px"
            };
            windowObject.onresize()
        })
    }
    WinJS.Namespace.define("BingApp.FilePicker",{initializeView: initializeView});
    var application = WinJS.Application;
    application.addEventListener("activated",function handleActivation(eventObject)
    {
        if(eventObject.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.fileOpenPicker)
            eventObject.setPromise(WinJS.UI.processAll().then(function initialize()
            {
                var direction = document.body.currentStyle.direction;
                var viewModel = new BingApp.Classes.FilePickerViewModel(eventObject.detail.fileOpenPickerUI,direction,window);
                BingApp.FilePicker.initializeView(viewModel,window,document)
            }))
    });
    application.start()
})()