﻿(function DisabledAuthenticatorModule()
{
    "use strict";
    var DisabledAuthenticator = WinJS.Class.derive(BingApp.Classes.BaseAuthenticator,function constructor()
        {
            BingApp.traceInfo("DisabledAuthenticator constructor")
        },{
            getAuthenticationData: function()
            {
                return{}
            },
            isAuthenticated: function()
            {
                return false
            },
            trySilentSignIn: function()
            {
                return WinJS.Promise.as(false)
            },
            signIn: function()
            {
                return WinJS.Promise.wrapError(new WinJS.ErrorFromName("signIn operation disabled"))
            },
            signOut: function()
            {
                return WinJS.Promise.wrapError(new WinJS.ErrorFromName("signOut operation disabled"))
            }
        });
    WinJS.Namespace.define("BingApp.Classes",{DisabledAuthenticator: DisabledAuthenticator})
})()