﻿(function configModule()
{
    "use strict";
    function createInstance()
    {
        var identity = "CONFIG";
        return new BingApp.Classes.ConfigStore(identity,{
                app: {
                    general: {
                        supported: true,
                        host: [{
                                region: "be",
                                value: "http://be.bing.com"
                            },{
                                region: "br",
                                value: "http://br.bing.com"
                            },{
                                region: "cn",
                                value: "http://cn.bing.com"
                            },{
                                region: "hk",
                                value: "http://hk.bing.com"
                            },{
                                region: "it",
                                value: "http://it.bing.com"
                            },{
                                region: "nz",
                                value: "http://nz.bing.com"
                            },{value: "http://www.bing.com"}],
                        secureHost: [{value: "https://ssl.bing.com"}],
                        configUpdateInterval: 864e5,
                        proxyTimeoutInterval: 5e3,
                        videoVerticalSupportedInApp: false
                    },
                    directNavigationAppUris: {sensitiveWordsBlock: {value: "ms-appx://microsoft.bing/shell/html/sensitivewordsblock.html"}}
                },
                authentication: {
                    general: {
                        reauthenticationDelayBeforeExpirySeconds: 60,
                        sourceName: "SoUp_w8bsa",
                        tokenSignInPath: "/fd/auth/signin",
                        tokenSignOutPath: "/fd/id/clear",
                        csrfLength: 16
                    },
                    facebook: {
                        enabled: [{
                                language: "en",
                                region: "us",
                                value: true
                            },{value: false}],
                        facebookLogOutUrl: "https://www.facebook.com/logout.php",
                        facebookGraphUrl: "https://graph.facebook.com/me",
                        tokenExpirySeconds: 7200,
                        ssoSignInPath: "/win8app/sso/fb/signin",
                        ssoSignOutPath: "/win8app/sso"
                    },
                    liveId: {tokenExpirySeconds: 1209600}
                },
                instrumentation: {general: {addLoginSource: false}},
                tracing: {
                    error: {
                        enabled: true,
                        recorded: true
                    },
                    warning: {
                        enabled: true,
                        recorded: true
                    },
                    info: {
                        enabled: true,
                        recorded: true
                    },
                    perf: {
                        enabled: true,
                        recorded: false
                    },
                    verbose: {
                        enabled: true,
                        recorded: false
                    },
                    settings: {maxRecorded: 500}
                },
                api: {general: {
                        host: "http://api.bing.com",
                        appID: "D4B405B6A89D7C283B6DA94C7275E7F8278FC54C"
                    }},
                autosuggest: {searchPane: {enabled: true}},
                errorLogging: {general: {maxErrorsInQueue: 10}},
                rewards: {general: {
                        enabled: [{
                                language: "en",
                                region: "us",
                                value: true
                            },{value: false}],
                        exploreUrl: "/explore/rewards?publ=BING_APP_W8&crea=BING_APP_W8"
                    }},
                voice: {general: {
                        enabled: false,
                        clientId: "73402000-b97b-46d3-b0a9-8af6a9ed3e77",
                        url: "http://api.m.bing.net/speechreco/win8/query",
                        loggingUrl: "http://api.m.bing.net/speechreco/win8/log",
                        testMode: false
                    }},
                trends: {
                    general: {
                        enabled: [{
                                region: "ca",
                                value: true
                            },{
                                region: "cn",
                                value: true
                            },{
                                region: "de",
                                value: true
                            },{
                                region: "fr",
                                value: true
                            },{
                                region: "gb",
                                value: true
                            },{
                                region: "jp",
                                value: true
                            },{
                                region: "us",
                                value: true
                            },{value: false}],
                        maxColumns: 8,
                        ttl: 21600
                    },
                    popularNowVisual: {
                        enabled: [{
                                region: "us",
                                value: true
                            },{value: false}],
                        url: [{
                                region: "us",
                                value: "http://binghomepagetool.blob.core.windows.net/popularnow/{date}.xml"
                            },{value: ""}]
                    },
                    popularNowText: {
                        enabled: [{
                                region: "ca",
                                value: true
                            },{
                                region: "cn",
                                value: true
                            },{
                                region: "de",
                                value: true
                            },{
                                region: "fr",
                                value: true
                            },{
                                region: "gb",
                                value: true
                            },{
                                region: "jp",
                                value: true
                            },{
                                region: "us",
                                value: true
                            },{value: false}],
                        url: [{
                                region: "ca",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_EN-CA.xml"
                            },{
                                region: "cn",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_ZH-CN.xml"
                            },{
                                region: "de",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_DE-DE.xml"
                            },{
                                region: "fr",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_FR-FR.xml"
                            },{
                                region: "gb",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_EN-GB.xml"
                            },{
                                region: "jp",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_JA-JP.xml"
                            },{
                                region: "us",
                                value: "http://az29176.vo.msecnd.net/popnow-desktopversion/PopNow_EN-US.xml"
                            },{value: ""}]
                    },
                    msnTrends: {
                        enabled: [{
                                region: "us",
                                value: true
                            },{value: false}],
                        url: [{
                                region: "us",
                                value: "http://www.msn.com/rss/searchabstract.aspx"
                            },{value: ""}]
                    },
                    bingNews: {
                        enabled: [{
                                region: "us",
                                value: true
                            },{value: false}],
                        url: [{
                                region: "us",
                                value: "http://api.bing.net/json.aspx?appid=374056632DA9D49D5D2076EF09C549BE58B7B09E&query=&newsvertical.offset=0&sources=newsvertical&version=2.4&newsvertical.count=20"
                            },{value: ""}],
                        maxItems: 3
                    },
                    popNowTrends: {
                        enabled: [{
                                region: "ca",
                                value: true
                            },{
                                region: "cn",
                                value: true
                            },{
                                region: "de",
                                value: true
                            },{
                                region: "fr",
                                value: true
                            },{
                                region: "gb",
                                value: true
                            },{
                                region: "jp",
                                value: true
                            },{
                                region: "us",
                                value: true
                            },{value: false}],
                        path: "/livetile/",
                        ttl: 24 * 60 * 60
                    }
                },
                search: {safeSearch: {
                        safeSearch: "DEMOTE",
                        restricted: [{
                                region: "ae",
                                value: true
                            },{
                                region: "bh",
                                value: true
                            },{
                                region: "cn",
                                value: true
                            },{
                                region: "dz",
                                value: true
                            },{
                                region: "eg",
                                value: true
                            },{
                                region: "id",
                                value: true
                            },{
                                region: "in",
                                value: true
                            },{
                                region: "iq",
                                value: true
                            },{
                                region: "jo",
                                value: true
                            },{
                                region: "kr",
                                value: true
                            },{
                                region: "kw",
                                value: true
                            },{
                                region: "lb",
                                value: true
                            },{
                                region: "ly",
                                value: true
                            },{
                                region: "ma",
                                value: true
                            },{
                                region: "my",
                                value: true
                            },{
                                region: "om",
                                value: true
                            },{
                                region: "qa",
                                value: true
                            },{
                                region: "sa",
                                value: true
                            },{
                                region: "sg",
                                value: true
                            },{
                                region: "th",
                                value: true
                            },{
                                region: "tn",
                                value: true
                            },{
                                region: "tr",
                                value: true
                            },{
                                region: "xa",
                                value: true
                            },{
                                region: "ye",
                                value: true
                            },{value: false}],
                        settingUrl: "/settings.aspx?pref_sbmt=1&adlt_set={0}&adlt_confirm=1&GUID={1}"
                    }},
                settingsPane: {
                    termsOfUse: {privacyStatementUrl: "http://g.msn.com/1ewBingWin8/SettingsPrivacy"},
                    internetContentProvider: {showMessage: [{
                                region: "cn",
                                value: true
                            },{value: false}]},
                    impressum: {
                        enabled: [{
                                region: "at",
                                value: true
                            },{
                                region: "ch",
                                value: true
                            },{
                                region: "de",
                                value: true
                            },{value: false}],
                        url: [{
                                region: "at",
                                value: "http://www.microsoft.com/de-at/unternehmen/rechtliches/impressum.aspx"
                            },{
                                region: "ch",
                                value: "http://www.microsoft.com/switzerland/microsoft-schweiz/de/unternehmen/impressum.mspx"
                            },{
                                region: "de",
                                value: "http://de.msn.com/Impressum.aspx"
                            },{value: ""}]
                    },
                    testConfiguration: {enabled: false},
                    feedback: {
                        url: "https://feedback.discoverbing.com/eformpost.aspx",
                        likeOrDislikeId: "FD8C313A-FF5B-4D5C-B",
                        commentId: "BDED91FC-2D64-4D36-A",
                        usageId: "79DD6AA6-5937-459A-9",
                        rateId: "8D66D9FC-4D23-45A6-9",
                        marketId: "2D4DD1B4-2907-4D35-B",
                        screenResolutionId: "F3A98558-1BD9-47CD-9",
                        archId: "28DFC297-F3F5-43E8-8",
                        appVersionId: "EEDB9897-C13A-4762-B",
                        latLotId: "0FD2B25D-FCDB-4F77-9",
                        locationAccuracyId: "B1AD7E05-6A79-4ADA-A",
                        networkId: "9A97D97E-42B7-439D-9",
                        productKey: "bingsearchwin8"
                    }
                },
                filePicker: {general: {
                        appId: "95CFCAD519525960235498A4B079DC3E045B20DC",
                        url: "http://www.bing.com/images/appxml",
                        apiVersion: "1.3"
                    }},
                justType: {general: {enabled: true}},
                searchHistory: {general: {enabled: false}},
                geolocation: {general: {
                        enabled: true,
                        reverseGeocodingEnabled: true,
                        mapsReverseGeocodingServiceUrl: "https://dev.virtualearth.net/REST/v1/Locations/{0},{1}?o=json&key=AqeGJ6NKccs5w6J-AJZ2So22ZCD7ZpJblD6McdOIMNTYHtYf94gqixnQXOV2O5Dt",
                        geolocatorReportInterval: 5e3,
                        geolocatorMovementThreshold: 500,
                        coordinatePrecision: 2
                    }}
            })
    }
    WinJS.Namespace.define("BingApp.Classes.Config",{createInstance: createInstance})
})()