﻿(function feedbackfragmentModule()
{
    "use strict";
    var likeString = "like";
    var dislikeString = "dislike";
    WinJS.Namespace.define("CommonJS.Feedback",{
        likeStatus: "like",
        ratingValues: ["Very good","Good","Average","Poor","Very poor"],
        frequencyValues: ["More than once a day","Daily","Weekly","A few times a month","I just started using this app"],
        onKeyDown: function(e)
        {
            switch(e.keyCode)
            {
                case WinJS.Utilities.Key.upArrow:
                    if(document.activeElement.id === "buttonDislike")
                    {
                        var elementLike = document.querySelector("#buttonLike");
                        if(elementLike)
                            elementLike.focus()
                    }
                    break;
                case WinJS.Utilities.Key.downArrow:
                    if(document.activeElement.id === "buttonLike")
                    {
                        var elementDislike = document.querySelector("#buttonDislike");
                        if(elementDislike)
                            elementDislike.focus()
                    }
                    break
            }
        },
        backToSettings: function(e)
        {
            e.currentTarget.removeEventListener("click",backToSettings);
            try
            {
                WinJS.UI.SettingsFlyout.show();
                BingApp.traceInfo("feedbackfragment.backToSettings: feedbackfragment is closed")
            }
            catch(err)
            {
                BingApp.traceError("feedbackfragment.backToSettings: failed to show the SettingsFlyout; Error: {0}.",err.message)
            }
        },
        like: function()
        {
            var elementLike = document.querySelector("#buttonLike");
            var elementDislike = document.querySelector("#buttonDislike");
            var questionTitle = document.querySelector("#questionTitle");
            var userSuggest = document.querySelector("#userSuggest");
            var likeCommentQuestion = WinJS.Resources.getString("feedback_like_comment_question").value;
            CommonJS.Feedback.likeStatus = likeString;
            questionTitle.innerText = likeCommentQuestion;
            userSuggest.title = likeCommentQuestion;
            elementLike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivSelected feedbackColor";
            elementDislike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivUnselected feedbackColor"
        },
        dislike: function()
        {
            var elementLike = document.querySelector("#buttonLike");
            var elementDislike = document.querySelector("#buttonDislike");
            var questionTitle = document.querySelector("#questionTitle");
            var userSuggest = document.querySelector("#userSuggest");
            var dislikeCommentQuestion = WinJS.Resources.getString("feedback_dislike_comment_question").value;
            CommonJS.Feedback.likeStatus = dislikeString;
            questionTitle.innerText = dislikeCommentQuestion;
            userSuggest.title = dislikeCommentQuestion;
            elementDislike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivSelected feedbackColor";
            elementLike.className = "feedbackDivTableLeftTdDiv feedbackDivTableLeftTdDivUnselected feedbackColor"
        },
        onFeedbackInputChange: function()
        {
            var userSuggest = document.querySelector("#userSuggest");
            var currentTime = new Date;
            CommonJS.feedbackAutosaveTime = currentTime.getTime();
            CommonJS.feedbackAutosave = userSuggest.innerText
        },
        sendFeedback: function(options)
        {
            var messageBar = null;
            var progressIndicatorService = BingApp.locator.progressIndicatorService;
            if(!window.navigator.onLine)
            {
                messageBar = new CommonJS.MessageBar(WinJS.Resources.getString("feedback_error_no_network").value,{autoHide: true});
                messageBar.show();
                return WinJS.Promise.as(false)
            }
            var select1 = document.querySelector("#question1");
            var select2 = document.querySelector("#question2");
            var userSuggest = document.querySelector("#userSuggest");
            var questionTitle = document.querySelector("#questionTitle");
            var userLike = CommonJS.Feedback.likeStatus;
            var answer1 = "NA";
            var answer2 = "NA";
            var userComment = "NA";
            if(select1.selectedIndex !== -1 && select1.selectedIndex < CommonJS.Feedback.frequencyValues.length)
                answer1 = CommonJS.Feedback.frequencyValues[select1.selectedIndex];
            BingApp.traceVerbose('Answer of "How often do you use this app?" question is: ' + answer1);
            if(select2.selectedIndex !== -1 && select2.selectedIndex < CommonJS.Feedback.ratingValues.length)
                answer2 = CommonJS.Feedback.ratingValues[select2.selectedIndex];
            BingApp.traceVerbose('Answer of "How would you rate this app??" question is: ' + answer2);
            var regS = /\"/g;
            userComment = userSuggest.innerText.replace(regS,"'").slice(0,1e3);
            BingApp.traceVerbose("User comments: " + userComment);
            BingApp.traceVerbose("User like status: " + userLike);
            var feedbackConfig = options && options.feedback || BingApp.locator.config.getConfig().settingsPane.feedback;
            var productKey = feedbackConfig.productKey;
            if(!productKey)
            {
                productKey = "";
                BingApp.traceError("Something goes wrong, could not find the feedback product key, feedback data will not be sent.")
            }
            else
            {
                var feedbackUrl = feedbackConfig.url + "?locale=en-us&productKey=" + encodeURIComponent(productKey) + "&ct=feedback&subtype=free";
                var fullVersion = BingApp.Classes.Shell.fullVersion;
                var screenResolution = BingApp.Utilities.format("{0}x{1}",BingApp.Utilities.getPageDimensions().width,BingApp.Utilities.getPageDimensions().height);
                var architectureString = BingApp.Utilities.getArchitecture();
                var fbSettingID = "returnQuery=%3Fproductkey%3D";
                var fbSettingIDAnswer = productKey;
                var misc = "&eformpost=true&feedbackParam1=&feedbackParam2=&feedbackParam3=&feedbackParam4=&feedbackParam5=&feedbackParam6=&feedbackParam7=&feedbackParam8=&feedbackParam9=&feedbackParam10=&feedbackParam11=&feedbackParam12=&feedbackParam13=&feedbackParam14=&feedbackParam15=&feedbackParam16=&feedbackParam17=&feedbackParam18=";
                var fbParamLike = "&" + feedbackConfig.likeOrDislikeId + "=";
                var fbParamLikeAnswer = encodeURIComponent(userLike);
                var fbParamComment = "&" + feedbackConfig.commentId + "=";
                var fbParamCommentAnswer = encodeURIComponent(userComment);
                var fbParamFrequency = "&" + feedbackConfig.usageId + "=";
                var fbParamFrequencyAnswer = encodeURIComponent(answer1);
                var fbParamRate = "&" + feedbackConfig.rateId + "=";
                var fbParamRateAnswer = encodeURIComponent(answer2);
                var fbParamResolution = "&" + feedbackConfig.screenResolutionId + "=";
                var fbParamResolutionAnswer = encodeURIComponent(screenResolution);
                var fbParamArch = "&" + feedbackConfig.archId + "=";
                var fbParamArchAnswer = encodeURIComponent(architectureString);
                var fbParamBuildNO = "&" + feedbackConfig.appVersionId + "=";
                var fbParamBuildNOAnswer = encodeURIComponent(fullVersion);
                var fbParamLatLong = "&" + feedbackConfig.latLotId + "=";
                var fbParamLatLongAnswer = encodeURIComponent(Windows.System.UserProfile.GlobalizationPreferences.homeGeographicRegion);
                var fbParamGEO = "&" + feedbackConfig.locationAccuracyId + "=";
                var fbParamGEOAnswer = "";
                var fbParamNetworkStatus = "&" + feedbackConfig.networkId + "=";
                var fbParamNetworkStatusAnswer = "";
                var fbMarket = "&" + feedbackConfig.marketId + "=";
                var fbMarketAnswer = encodeURIComponent(Windows.System.UserProfile.GlobalizationPreferences.languages[0]);
                var params = fbSettingID + fbSettingIDAnswer + misc + fbParamLike + fbParamLikeAnswer + fbParamComment + fbParamCommentAnswer + fbParamFrequency + fbParamFrequencyAnswer + fbParamRate + fbParamRateAnswer + fbParamResolution + fbParamResolutionAnswer + fbParamArch + fbParamArchAnswer + fbParamBuildNO + fbParamBuildNOAnswer + fbParamLatLong + fbParamLatLongAnswer + fbParamGEO + fbParamGEOAnswer + fbParamNetworkStatus + fbParamNetworkStatusAnswer + fbMarket + fbMarketAnswer;
                var sendFeedbackJob = progressIndicatorService.startJob();
                userSuggest.innerText = "";
                CommonJS.feedbackAutosave = "";
                var sharedFeedbackPage = document.querySelector("#sharedFeedbackPage");
                sharedFeedbackPage.winControl.hide();
                return WinJS.xhr({
                        url: feedbackUrl,
                        data: params,
                        type: "POST",
                        headers: {
                            "Content-type": "application/x-www-form-urlencoded",
                            "Content-length": params.length,
                            "Accept-Encoding": "gzip, deflate",
                            Host: "feedback.discoverbing.com",
                            "User-Agent": window.navigator.userAgent,
                            Connection: "close"
                        }
                    }).then(function sendFeedbackCompleted(result)
                    {
                        progressIndicatorService.finishJob(sendFeedbackJob);
                        if(result.status === 200)
                        {
                            messageBar = new CommonJS.MessageBar(WinJS.Resources.getString("feedback_thank_you").value,{autoHide: true});
                            messageBar.show();
                            BingApp.traceInfo("Feedback submitted.");
                            return WinJS.Promise.as(true)
                        }
                        messageBar = new CommonJS.MessageBar(WinJS.Resources.getString("feedback_error_submit_failed").value,{autoHide: true});
                        messageBar.show();
                        var errorMessage = "Feedback submit failed.";
                        var instObject = {
                                url: feedbackUrl,
                                sc: result.status,
                                ei: errorMessage
                            };
                        BingApp.Instrumentation.logError(instObject);
                        BingApp.traceError(errorMessage);
                        return WinJS.Promise.as(false)
                    },function sendFeedbackError(error)
                    {
                        progressIndicatorService.finishJob(sendFeedbackJob);
                        messageBar = new CommonJS.MessageBar(WinJS.Resources.getString("feedback_error_submit_failed").value,{autoHide: true});
                        messageBar.show();
                        var errorMessage = "Feedback submit failed.";
                        var instObject = {
                                url: feedbackUrl,
                                ei: errorMessage
                            };
                        BingApp.Instrumentation.logError(instObject);
                        BingApp.traceError(errorMessage);
                        return WinJS.Promise.as(false)
                    })
            }
        }
    })
})()