﻿(function feedbackfragmentcontrollerModule()
{
    "use strict";
    WinJS.Namespace.define("CommonJS.Feedback",{
        timeoutThreshold: 18e5,
        questionsCount: 2,
        optionsCount: 5,
        onFeedbackCmd: function(eventData)
        {
            CommonJS.Feedback.addFeedbackPageFragment().done(function feedback_addFeedbackPageComplete(feedbackFlyout)
            {
                if(feedbackFlyout)
                {
                    var backButton = document.querySelector("#backToSettings");
                    var buttonLike = document.querySelector("#buttonLike");
                    var buttonDislike = document.querySelector("#buttonDislike");
                    var userSuggest = document.querySelector("#userSuggest");
                    var feedbackSubmit = document.querySelector("#feedbackSubmit");
                    backButton.addEventListener("click",CommonJS.Feedback.backToSettings);
                    buttonLike.addEventListener("click",CommonJS.Feedback.like);
                    buttonDislike.addEventListener("click",CommonJS.Feedback.dislike);
                    userSuggest.addEventListener("input",CommonJS.Feedback.onFeedbackInputChange);
                    feedbackSubmit.addEventListener("click",CommonJS.Feedback.sendFeedback);
                    feedbackFlyout.addEventListener("afterhide",function feedbackFlyout_onAfterHide(event)
                    {
                        CommonJS.Feedback.removeFeedbackPageFragment()
                    });
                    feedbackFlyout.addEventListener("aftershow",function feedbackFlyout_onAfterShow(event)
                    {
                        if(userSuggest)
                            userSuggest.focus();
                        BingApp.traceVerbose("Feedback opened")
                    });
                    feedbackFlyout.addEventListener("keydown",CommonJS.Feedback.onKeyDown);
                    var question1 = document.querySelector("#question1");
                    var question2 = document.querySelector("#question2");
                    if(question1)
                        question1.selectedIndex = -1;
                    if(question2)
                        question2.selectedIndex = -1;
                    feedbackFlyout.show()
                }
            },BingApp.Utilities.createTraceErrorHandler("feedbackfragmentcontroller.onFeedbackCmd: failed to add feedback page fragment"))
        },
        removeFeedbackPageFragment: function()
        {
            var feedbackElement = document.querySelector("#feedbackPageDiv");
            if(feedbackElement)
            {
                var backButton = feedbackElement.querySelector("#backToSettings");
                var buttonLike = feedbackElement.querySelector("#buttonLike");
                var buttonDislike = feedbackElement.querySelector("#buttonDislike");
                var userSuggest = feedbackElement.querySelector("#userSuggest");
                var feedbackSubmit = feedbackElement.querySelector("#feedbackSubmit");
                backButton.removeEventListener("click",CommonJS.Feedback.backToSettings);
                buttonLike.removeEventListener("click",CommonJS.Feedback.like);
                buttonDislike.addEventListener("click",CommonJS.Feedback.dislike);
                userSuggest.removeEventListener("input",CommonJS.Feedback.onFeedbackInputChange);
                feedbackSubmit.removeEventListener("click",CommonJS.Feedback.sendFeedback);
                document.body.removeChild(feedbackElement)
            }
        },
        addFeedbackPageFragment: function(options)
        {
            var config = options && options.config || BingApp.locator.config;
            var feedbackElement = document.querySelector("#feedbackPageDiv");
            if(!feedbackElement)
            {
                feedbackElement = document.createElement("div");
                feedbackElement.id = "feedbackPageDiv";
                document.body.appendChild(feedbackElement)
            }
            return WinJS.UI.Pages.render("/shell/html/feedbackFragment.html",feedbackElement).then(function feedback_renderCopyFragmentComplete(doc)
                {
                    var autoSavedComment = "";
                    var currentTime = Date.now();
                    var privacyStatementUrl = config.getConfig().settingsPane.termsOfUse.privacyStatementUrl;
                    if(CommonJS.feedbackAutosaveTime && currentTime - CommonJS.feedbackAutosaveTime < CommonJS.Feedback.timeoutThreshold)
                        if(CommonJS.feedbackAutosave)
                        {
                            autoSavedComment = CommonJS.feedbackAutosave;
                            CommonJS.feedbackAutosaveTime = currentTime
                        }
                    WinJS.Resources.processAll(feedbackElement);
                    var sharedFeedbackPage = document.querySelector("#sharedFeedbackPage");
                    var userSuggestElement = sharedFeedbackPage.querySelector("#userSuggest");
                    var feedbackPrivacyLinkElement = sharedFeedbackPage.querySelector("#feedbackPrivacyLink");
                    userSuggestElement.innerText = autoSavedComment;
                    feedbackPrivacyLinkElement.href = privacyStatementUrl;
                    return WinJS.Promise.as(sharedFeedbackPage.winControl)
                },BingApp.Utilities.createTraceErrorHandler("Feedback.addFeedbackPageFragment: failed to render feedback page html"))
        }
    })
})()