﻿(function helpModule()
{
    "use strict";
    function hideHelpFlyout(eventData)
    {
        eventData.target.removeEventListener("click",backToSettings);
        try
        {
            WinJS.UI.SettingsFlyout.show();
            BingApp.traceInfo("help.backToSettings: help is closed")
        }
        catch(err)
        {
            BingApp.traceError("help.backToSettings: failed to show the SettingsFlyout; Error: {0}.",err.message)
        }
    }
    function clickHandler(eventData)
    {
        var marketStrings = new Windows.ApplicationModel.Resources.ResourceLoader("market");
        var url;
        switch(eventData.target.id)
        {
            case"firstLink":
                url = marketStrings.getString("HELP_FIRST_LINK_URL");
                break;
            case"secondLink":
                url = marketStrings.getString("HELP_SECOND_LINK_URL");
                break;
            case"thirdLink":
                url = marketStrings.getString("HELP_THIRD_LINK_URL");
                break;
            default:
                url = "";
                break
        }
        BingApp.Utilities.invokeURI(url)
    }
    function keyDownHandler(eventData)
    {
        if(BingApp.Utilities.isKeyDownAndSpaceOrEnterKey(eventData))
            clickHandler(eventData)
    }
    WinJS.Namespace.define("BingApp.Help",{
        hideHelpFlyout: hideHelpFlyout,
        clickHandler: clickHandler,
        keyDownHandler: keyDownHandler
    })
})()