﻿(function helpcontrollerModule()
{
    "use strict";
    function onHelpCmd(eventData)
    {
        BingApp.Help.addHelpPageFragment().then(function addHelpPageComplete(helpFlyout)
        {
            if(helpFlyout)
            {
                var backButton = document.querySelector("#backToSettings");
                var firstLink = document.querySelector("#firstLink");
                var secondLink = document.querySelector("#secondLink");
                var thirdLink = document.querySelector("#thirdLink");
                backButton.addEventListener("click",BingApp.Help.hideHelpFlyout);
                firstLink.addEventListener("click",BingApp.Help.clickHandler);
                firstLink.addEventListener("keydown",BingApp.Help.keyDownHandler);
                secondLink.addEventListener("click",BingApp.Help.clickHandler);
                secondLink.addEventListener("keydown",BingApp.Help.keyDownHandler);
                thirdLink.addEventListener("click",BingApp.Help.clickHandler);
                thirdLink.addEventListener("keydown",BingApp.Help.keyDownHandler);
                helpFlyout.addEventListener("afterhide",function feedbackFlyout_onAfterHide(event)
                {
                    BingApp.Help.removeHelpPageFragment()
                });
                helpFlyout.addEventListener("aftershow",function helpFlyout_onAfterShow(event)
                {
                    BingApp.traceVerbose("Help opened")
                });
                helpFlyout.show()
            }
        })
    }
    function removeHelpPageFragment()
    {
        var helpElement = document.querySelector("#helpPageDiv");
        if(helpElement)
        {
            var backButton = helpElement.querySelector("#backToSettings");
            var firstLink = helpElement.querySelector("#firstLink");
            var secondLink = helpElement.querySelector("#secondLink");
            var thirdLink = helpElement.querySelector("#thirdLink");
            backButton.removeEventListener("click",BingApp.Help.hideHelpFlyout);
            firstLink.removeEventListener("click",BingApp.Help.clickHandler);
            firstLink.removeEventListener("keydown",BingApp.Help.keyDownHandler);
            secondLink.removeEventListener("click",BingApp.Help.clickHandler);
            secondLink.removeEventListener("keydown",BingApp.Help.keyDownHandler);
            thirdLink.removeEventListener("click",BingApp.Help.clickHandler);
            thirdLink.removeEventListener("keydown",BingApp.Help.keyDownHandler);
            document.body.removeChild(helpElement)
        }
    }
    function addHelpPageFragment()
    {
        var helpElement = document.querySelector("#helpPageDiv");
        if(!helpElement)
        {
            helpElement = document.createElement("div");
            helpElement.id = "helpPageDiv";
            document.body.appendChild(helpElement)
        }
        return WinJS.UI.Pages.render("/shell/html/help.html",helpElement).then(function help_renderCopyFragmentComplete()
            {
                WinJS.Resources.processAll();
                var helpSettingsDiv = document.querySelector("#helpSettingsDiv");
                return WinJS.Promise.as(helpSettingsDiv.winControl)
            },function help_fragmentRenderCopyError(error)
            {
                BingApp.traceError("Help.addHelpPageFragment failed. Error: {0}",error && error.message)
            })
    }
    WinJS.Namespace.define("BingApp.Help",{
        onHelpCmd: onHelpCmd,
        removeHelpPageFragment: removeHelpPageFragment,
        addHelpPageFragment: addHelpPageFragment
    })
})()