﻿(function msappErrorModule()
{
    "use strict";
    var failureUrlKey = "failureUrl";
    var failureNameKey = "failureName";
    var navigationErrorPageUri = "/shell/html/navigationerror.html";
    var defaultSearchBoxUri = "/shell/html/defaultsearchbox.html";
    var keyValuePairMatch = /([^?=&]+)(=([^&]*))?/g;
    function initMsAppError(environment, windowObject, pages)
    {
        if(windowObject.parent === windowObject)
        {
            BingApp.traceError("Error page should be loaded in web context, not in the app compartment.");
            throw new BingApp.Classes.ErrorInvalidOperation("BingApp.ErrorPage.init",WinJS.Resources.getString("error_error_page_in_app_context").value);
        }
        var queryString = windowObject.location.search;
        var parsedQueryString = {};
        queryString.replace(keyValuePairMatch,function onMatch(match, key, equalValue, value)
        {
            if(value)
                parsedQueryString[key] = decodeURIComponent(value);
            else
                parsedQueryString[key] = ""
        });
        environment.configurationReady().then(function renderErrorPage()
        {
            var config = BingApp.Classes.Config.createInstance();
            var searchBoxUrl = config.getConfig().app.general.host + environment.configuration["searchBoxPage"];
            var uri;
            var failureUrl = parsedQueryString[failureUrlKey];
            if(failureUrl === searchBoxUrl || failureUrl.indexOf(searchBoxUrl + "?") === 0)
                uri = defaultSearchBoxUri;
            else
                uri = navigationErrorPageUri;
            var errorHostElement = document.querySelector("#errorHost");
            WinJS.Utilities.empty(errorHostElement);
            pages.render(uri,errorHostElement)
        })
    }
    WinJS.Namespace.define("BingApp.ErrorPage",{initMsAppError: initMsAppError});
    WinJS.Utilities.ready().done(function initMsAppError()
    {
        var environment = new BingApp.Classes.Env({config: {}});
        BingApp.ErrorPage.initMsAppError(environment,window,WinJS.UI.Pages)
    })
})()