﻿(function navigationErrorModule()
{
    "use strict";
    var messageError = "error:network";
    var messageRetry = "error:retry";
    var eventNames = BingApp.Classes.IframeHostController.eventNames;
    function initNavigationError(windowObject)
    {
        var origin = windowObject.location.protocol + "//" + windowObject.location.host;
        var queryString = windowObject.location.search;
        if(queryString.length > 0)
            BingApp.traceError("msapp-error information: " + queryString);
        message = JSON.stringify({name: eventNames.contentReady});
        windowObject.parent.postMessage(message,origin);
        var message = JSON.stringify({
                name: messageError,
                value: {error: queryString}
            });
        windowObject.parent.postMessage(message,origin);
        WinJS.Resources.processAll();
        var retryButtonElement = document.querySelector("#retryButton");
        retryButtonElement.addEventListener("click",function onRetryButtonClicked()
        {
            var retryMessage = JSON.stringify({name: messageRetry});
            windowObject.parent.postMessage(retryMessage,origin)
        });
        windowObject.addEventListener("message",function onWindowMessage(eventData)
        {
            if(eventData.origin === origin)
            {
                var receivedMessage;
                try
                {
                    receivedMessage = JSON.parse(eventData.data)
                }
                catch(error)
                {
                    BingApp.traceError("NavigationError.onMessage: error while parsing message '{0}' from app compartment; error message: '{1}'.",eventData.data,error.message);
                    receivedMessage = null
                }
                if(receivedMessage && receivedMessage.name === eventNames.navigateOut && receivedMessage.value.navigationUri)
                {
                    var reply = JSON.stringify({
                            name: eventNames.navigateTo,
                            value: {uri: receivedMessage.value.navigationUri}
                        });
                    windowObject.parent.postMessage(reply,origin)
                }
            }
        },false);
        windowObject.addEventListener("resize",function onWindowResize()
        {
            var errorMessageElement = document.querySelector("#errorMessage");
            if(Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.snapped)
            {
                WinJS.Utilities.addClass(errorMessageElement,"fontMedium");
                WinJS.Utilities.removeClass(errorMessageElement,"fontLarge")
            }
            else
            {
                WinJS.Utilities.addClass(errorMessageElement,"fontLarge");
                WinJS.Utilities.removeClass(errorMessageElement,"fontMedium")
            }
        },false)
    }
    WinJS.Namespace.define("BingApp.ErrorPage",{initNavigationError: initNavigationError});
    function ready()
    {
        WinJS.UI.processAll();
        BingApp.ErrorPage.initNavigationError(window);
        BingApp.traceInfo("NavigationError.ready: navigation error page is displayed.")
    }
    WinJS.UI.Pages.define("/shell/html/navigationerror.html",{ready: ready})
})()