﻿(function searchPaneModule()
{
    "use strict";
    var events = Object.freeze({visibilityChanged: "searchPane:visibilityChanged"});
    var eventRelay;
    function init(relay)
    {
        if(!relay)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("relay");
        eventRelay = relay;
        var searchPane = Windows.ApplicationModel.Search.SearchPane.getForCurrentView();
        function onVisibilityChanging(eventData)
        {
            relay.fireEvent(events.visibilityChanged,{visible: eventData.visible})
        }
        searchPane.addEventListener("visibilitychanged",onVisibilityChanging)
    }
    function handleActivation(activationData)
    {
        BingApp.traceInfo("SearchPane.handleActivation: Start handler");
        if(activationData.detail.kind === Windows.ApplicationModel.Activation.ActivationKind.search)
        {
            BingApp.traceInfo("SearchPane.handleActivation: Search charm activation");
            var searchPane = Windows.ApplicationModel.Search.SearchPane.getForCurrentView();
            eventRelay && eventRelay.fireEvent(events.visibilityChanged,{visible: true}) && BingApp.traceInfo("SearchPane.handleActivation: Fired visibility event")
        }
    }
    function isVisible()
    {
        var searchPane = Windows.ApplicationModel.Search.SearchPane.getForCurrentView();
        return searchPane.visible
    }
    WinJS.Namespace.define("BingApp.SearchPane",{
        init: init,
        isVisible: isVisible,
        handleActivation: handleActivation,
        events: events
    })
})()