﻿(function sensitiveWordsBlockModule()
{
    "use strict";
    var eventNames = BingApp.Classes.IframeHostController.eventNames;
    function initSensitiveWordsBlock(windowObject)
    {
        var origin = windowObject.location.protocol + "//" + windowObject.location.host;
        var message = JSON.stringify({name: eventNames.contentReady});
        windowObject.parent.postMessage(message,origin);
        var marketStrings = new Windows.ApplicationModel.Resources.ResourceLoader("market");
        var helpURL = marketStrings.getString("HELP_GENERAL_LINK_URL");
        var errorMessageElement = document.getElementById("errorMessage");
        errorMessageElement.innerHTML = windowObject.toStaticHTML(BingApp.Utilities.format(WinJS.Resources.getString("error_sensitive_words_block_message").value,helpURL));
        errorMessageElement.querySelector(".extLink").setAttribute("target","ie");
        WinJS.Resources.processAll().done(function()
        {
            message = JSON.stringify({
                name: eventNames.contentLoaded,
                value: {uri: "ms-appx://microsoft.bing/shell/html/sensitivewordsblock.html"}
            });
            windowObject.parent.postMessage(message,origin)
        })
    }
    function ready()
    {
        WinJS.UI.processAll().done(function()
        {
            initSensitiveWordsBlock(window);
            BingApp.traceInfo("sensitivewordsblockpage.ready: sensitive words block page is displayed.")
        })
    }
    WinJS.UI.Pages.define("/shell/html/sensitivewordsblock.html",{ready: ready})
})()