﻿(function softKeyboardModule()
{
    "use strict";
    var events = Object.freeze({visibilityChanged: "inputpane:visibilitychanged"});
    function init(relay)
    {
        if(!relay)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("relay");
        var inputPane = Windows.UI.ViewManagement.InputPane.getForCurrentView();
        function onVisibilityChanging(eventData)
        {
            var visible = eventData.type.toLowerCase() === "showing";
            var activeElement = document.activeElement;
            if(visible && activeElement && activeElement.id === "searchbariframe")
                eventData.ensuredFocusedElementInView = true;
            relay.fireEvent(events.visibilityChanged,{
                visible: visible,
                occludeRect: eventData.occludedRect
            })
        }
        inputPane.addEventListener("showing",onVisibilityChanging);
        inputPane.addEventListener("hiding",onVisibilityChanging)
    }
    WinJS.Namespace.define("BingApp.SoftKeyboard",{
        init: init,
        events: events
    })
})()