﻿(function upgradeCheckModule()
{
    "use strict";
    var storeUpdateUri = "ms-windows-store:Updates";
    function _promptForUpgrade()
    {
        BingApp.traceInfo("Upgrade._promptForUpgrade: Prompting the user to upgrade to the latest version available on Store.");
        var msg = new Windows.UI.Popups.MessageDialog(WinJS.Resources.getString("update_version_out_of_date").value + WinJS.Resources.getString("update_download").value);
        msg.commands.append(new Windows.UI.Popups.UICommand(WinJS.Resources.getString("update_go_to").value,_forcedUpgradeHandler));
        msg.cancelCommandIndex = -2;
        msg.showAsync()
    }
    function _forcedUpgradeHandler()
    {
        BingApp.traceInfo("Upgrade._forcedUpgradeHandler: Forcing the user to upgrade the latest and greatest app version.");
        BingApp.Instrumentation.logClick({name: "Upgrade"});
        BingApp.Utilities.invokeURI(storeUpdateUri).done(function onComplete()
        {
            BingApp.traceInfo("Upgrade._forcedUpgradeHandler: Succeeded in navigating to the Store page for updates.");
            _promptForUpgrade()
        },function onError()
        {
            BingApp.traceInfo("Upgrade._forcedUpgradeHandler: Failed to navigate to the Store page for updates.");
            _promptForUpgrade()
        })
    }
    var UpgradeCheck = WinJS.Class.define(function upgradeCheckConstructor(options)
        {
            this._config = options && options.config || BingApp.locator.config;
            this._eventRelay = options && options.eventRelay || BingApp.locator.eventRelay;
            this._checkForUpgrade();
            var that = this;
            this._eventRelay.addEventListener(BingApp.Classes.ConfigStore.events.updated,function upgradeOnConfigUpdated()
            {
                that._checkForUpgrade()
            })
        },{_checkForUpgrade: function()
            {
                if(!this._config.getConfig().app.general.supported)
                    _promptForUpgrade()
            }});
    WinJS.Namespace.define("BingApp.Classes",{UpgradeCheck: UpgradeCheck})
})()