﻿(function viewStateModule()
{
    "use strict";
    var previousState;
    var viewStateEnumeration = Windows.UI.ViewManagement.ApplicationViewState;
    var applicationView = Windows.UI.ViewManagement.ApplicationView;
    function initDimensions(documentObject)
    {
        previousState = BingApp.Utilities.getViewMode(applicationView.value)
    }
    function init(windowObject, documentObject, relay)
    {
        if(!windowObject)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("windowObject");
        if(!documentObject)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("documentObject");
        if(!relay)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("relay");
        initDimensions(documentObject);
        function onResize()
        {
            var state = BingApp.Utilities.getViewMode(applicationView.value);
            if(previousState !== state)
            {
                BingApp.Instrumentation.log({
                    feature: BingApp.Instrumentation.String.native,
                    name: BingApp.Instrumentation.String.stateChange,
                    oldState: previousState ? previousState : BingApp.Instrumentation.String.initialState
                },BingApp.Instrumentation.modeChange);
                previousState = state
            }
        }
        windowObject.addEventListener("resize",onResize,false)
    }
    WinJS.Namespace.define("BingApp.ViewState",{init: init})
})()