﻿(function WinJSPatchModule()
{
    "use strict";
    function applyPatch()
    {
        var doneAction = function(onComplete, onError, onProgress)
            {
                this.then(onComplete,onError,onProgress).then(null,errorHandlerForPromiseException)
            };
        var errorPromise = WinJS.Promise.wrapError(null);
        Object.getPrototypeOf(errorPromise).done = doneAction;
        var completePromise = WinJS.Promise.wrap();
        Object.getPrototypeOf(completePromise).done = doneAction
    }
    function errorHandlerForPromiseException(err)
    {
        var cancelledName = "Canceled";
        if(!(err instanceof Error))
        {
            var description;
            try
            {
                description = JSON.stringify(err)
            }
            catch(e)
            {
                description = "[unknown description]"
            }
            err = new Error(description)
        }
        else if(err.message === cancelledName && err.name === cancelledName)
            return;
        terminateApp(err)
    }
    function terminateApp(error)
    {
        if(!error)
            error = new Error("[no original error]");
        if(typeof error.description !== "string")
            error.description = error.message || "[no original description/message]";
        if(typeof error.stack !== "string")
        {
            if(error instanceof Error)
                try
                {
                    throw error;
                }
                catch(ex)
                {
                    error.stack = ex.stack
                }
            if(typeof error.stack !== "string")
                error.stack = "[no original stack]"
        }
        if(typeof error.number !== "number" || isNaN(error.number))
            error.number = 0;
        MSApp.terminateApp(error)
    }
    applyPatch();
    WinJS.Namespace.define("BingApp.WinJSPatch",{applyPatch: applyPatch})
})()