﻿(function startViewModule()
{
    "use strict";
    var allListViewSelector = "#startPanorama .win-listview",
        containedViewHostSelector = "#containedviewhost",
        listBindingInProgress = false,
        mainViewMessageShowContent = "mainView:showContent",
        trendsListViewContainerSelector = "#trendsListViewContainer";
    var StartViewController = WinJS.Class.derive(BingApp.Classes.ViewController,function constructor(startViewPage, options)
        {
            BingApp.Classes.ViewController.call(this);
            this._navigationManager = options && options.navigationManager || BingApp.locator.navigationManager;
            this._eventRelay = options && options.eventRelay || BingApp.locator.eventRelay;
            this._startViewPage = startViewPage
        },{
            setNavigationUri: function(uri)
            {
                if(BingApp.locator.navigationManager.getCurrentContentStatus() === BingApp.Classes.NavigationManager.contentStatus.loading && this._viewIsInitialized)
                    BingApp.locator.navigationManager.notifyContentLoaded()
            },
            notifyViewReady: function()
            {
                BingApp.ShareSource.ondatarequested = ondatarequested;
                if(!this._onNetworkStatusChangeWrapper)
                {
                    var that = this;
                    this._onNetworkStatusChangeWrapper = function onNetworkStatusChangeWrapper(eventData)
                    {
                        that._startViewPage.onNetworkStatusChange(eventData)
                    }
                }
                if(!this._onShowContent)
                    this._onShowContent = function onShowContent(eventData)
                    {
                        var trendsListViewElement = document.querySelector("#trendsListView");
                        trendsListViewElement && trendsListViewElement.winControl && trendsListViewElement.winControl.forceLayout()
                    };
                this._eventRelay.addEventListener(BingApp.Classes.NetworkDetectionService.networkStatusChangedEvent,this._onNetworkStatusChangeWrapper);
                this._eventRelay.addEventListener(mainViewMessageShowContent,this._onShowContent);
                this._navigationManager.notifyContentLoaded();
                this._viewIsInitialized = true
            },
            notifyUnloading: function()
            {
                if(this._onNetworkStatusChangeWrapper)
                    this._eventRelay.removeEventListener(BingApp.Classes.NetworkDetectionService.networkStatusChangedEvent,this._onNetworkStatusChangeWrapper);
                if(this._onShowContent)
                    this._eventRelay.removeEventListener(mainViewMessageShowContent,this._onShowContent);
                if(BingApp.Classes.TrendingController.trendingViewRefreshListener)
                    this._eventRelay.removeEventListener(BingApp.Classes.ConfigStore.events.updated,BingApp.Classes.TrendingController.trendingViewRefreshListener);
                this._onNetworkStatusChangeWrapper = null;
                BingApp.Classes.TrendingController.trendingViewRefreshListener = null;
                BingApp.Classes.TrendingController.onUnload();
                BingApp.ShareSource.ondatarequested = null;
                listBindingInProgress = false;
                this._viewIsInitialized = false;
                BingApp.Classes.ViewController.prototype.notifyUnloading.call(this)
            },
            _onNetworkStatusChangeWrapper: null,
            _viewIsInitialized: false
        });
    function getController(options)
    {
        if(!this._controller)
            this._controller = new StartViewController(this,options);
        return this._controller
    }
    function ready()
    {
        var containedViewHost = document.querySelector(containedViewHostSelector);
        if(containedViewHost)
            containedViewHost.style.height = "100%";
        if(!BingApp.locator.networkDetectionService.isConnected())
            onNetworkStatusChange({connectionState: BingApp.Classes.NetworkDetectionService.connectionStates.none});
        else
            processTrends();
        this.getController().notifyViewReady()
    }
    function onNetworkStatusChange(eventData)
    {
        if(!eventData)
            throw new BingApp.Classes.ErrorArgumentNullOrUndefined("eventData");
        if(eventData.connectionState === BingApp.Classes.NetworkDetectionService.connectionStates.internetAccess)
            processTrends();
        else
            hideTrendsHub()
    }
    function processTrends()
    {
        var trendsListViewContainer = document.querySelector(trendsListViewContainerSelector);
        if(BingApp.Classes.TrendingController.trendsAvailableForCurrentMarket())
        {
            if(Windows.UI.ViewManagement.ApplicationView.value === Windows.UI.ViewManagement.ApplicationViewState.snapped)
                trendsListViewContainer.style.display = "-ms-grid";
            else
                trendsListViewContainer.style.display = "inline-block";
            if(!listBindingInProgress)
            {
                listBindingInProgress = true;
                BingApp.Classes.TrendingController.doBinding()
            }
            else
                BingApp.Classes.TrendingController.onVisible()
        }
        else
            hideTrendsHub()
    }
    function hideTrendsHub()
    {
        var trendsListViewContainerElement = document.querySelector("#trendsListViewContainer");
        trendsListViewContainerElement.style.display = "none"
    }
    function ondatarequested()
    {
        var defaultHost = BingApp.locator.config.getConfig().app.general.host;
        var collection = {};
        collection["form"] = BingApp.Classes.Shell.formCodes.fromShareCharmTrending;
        var uri = null;
        try
        {
            uri = new Windows.Foundation.Uri(defaultHost + BingApp.Utilities.QueryString.serialize(collection))
        }
        catch(e)
        {
            BingApp.traceError("startview.ondatarequested: invalid uri. Setting to null.")
        }
        var shareData = new BingApp.Classes.ShareData;
        shareData.title = WinJS.Resources.getString("app_name").value;
        shareData.description = WinJS.Resources.getString("app_description_short").value;
        shareData.uri = uri;
        BingApp.ShareSource.addShareSources(shareData)
    }
    WinJS.UI.Pages.define("/views/start/html/startview.html",{
        ready: ready,
        getController: getController,
        onNetworkStatusChange: onNetworkStatusChange,
        _controller: null,
        _directionFactor: undefined
    })
})()